(define (check-equal actual expected)
  (if (not (equal? actual expected))
      (error "check failed: " actual ", but expected " expected)
      actual))

(define (check-eq actual expected)
  (if (not (eq? actual expected))
      (error "check failed: " actual ", but expected " expected)
      actual))

(define (check= actual expected)
  (if (not (= actual expected))
      (error "check failed: " actual ", but expected " expected)
      actual))

(define (display-list . lst)
  ; uses variable-length argument list
  ; see section 4.1.4 of R5RS 
  ;  ( http://www.schemers.org/Documents/Standards/R5RS/r5rs.pdf )
  (map display lst)
  (newline))

(define (tagged-list? x tag)
  (and (pair? x) (eq? tag (car x))))

(define (fold-left op init lst)
  (if (null? lst)
      init
      (fold-left op (op (car lst) init) (cdr lst))))
