(load "helpers.scm")

; this version uses non-tagged representation for nicer printing

(load "bst-def.scm")

;;;;; Primitive Mutators

(load "primitive-mutators.scm")

;;;;; Higher-level operations

(load "depth0.scm")
(load "fold.scm")
(load "depth.scm")

(define (check-depth tree expected-depth)
  (check= (binary-tree/depth0 tree) expected-depth)
  (check= (binary-tree/depth  tree) expected-depth))

(define lr-tree 
  (make-node 'top
             (make-node 'l *empty-binary-tree* *empty-binary-tree*)
             (make-node 'r
                        (make-node 'rl *empty-binary-tree* *empty-binary-tree*)
                        *empty-binary-tree*)))
(check-depth lr-tree 3)
(check-depth '(() 1 (() 2 (() 3 (() 4 ())))) 4)

;;;;; Binary Search Tree 

(load "bst-insert.scm")
(load "bst-insert!.scm")
(load "list-bst.scm")

(list->bst '(1 2 3 4 5))
(list->bst '(5 3 1 2 7 6 9))

(load "bt-list.scm")
; we could write an efficient version with binary-tree/fold too, but
; the implementation gets a bit involved.

(load "sort.scm")

(define (check-sort lst)
  (let ((built-in (sort         lst <))
        (ours     (sort-via-bst lst  )))
    (check-equal ours built-in)
    ours))

(check-sort '(1 2 3 4 5))
(check-sort '(5 4 3 2 1))
(check-sort '(5 3 1 2 7 6 9))
(check-sort '())

